Last Comment Bug 2110 - NECKO: URI scheme parsing, extensibility broken/missing
: NECKO: URI scheme parsing, extensibility broken/missing
Status: VERIFIED FIXED
waiting for developer to verify
:
Product: Core
Classification: Components
Component: Networking (show other bugs)
: Trunk
: All All
: P1 major (vote)
: M9
Assigned To: Gagan
: Paul MacQuiddy
: Patrick McManus [:mcmanus]
Mentors:
: 1640 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 1998-12-31 21:31 PST by Dan Connolly
Modified: 2006-10-29 17:48 PST (History)
2 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Dan Connolly 1998-12-31 21:31:48 PST
NET_MakeAbsoluteURL is broken: it decides relative vs. absolute
based on a fixed set of known URL schemes, but it should
just look at the syntax.

http://cvs-mirror.mozilla.org/webtools/lxr/ident?i=NET_MakeAbsoluteURL

For example it parses g:h as a relative address, but it's absolute.
That's the 1st test case in Roy's suite:

http://www.ics.uci.edu/~fielding/url/test1.html

The URI syntax spec is now an IETF draft standard:
http://www.ics.uci.edu/~fielding/url/rfc2396.txt

For an implementation, see HTParse.c in libwww
http://dev.w3.org/cgi-bin/cvsweb/libwww/Library/src/HTParse.c?rev=2.79

Also, I see that on the Win and Mac platforms, the user
can add new URL schemes to their desktop (using
the registry on Win and some corresponding magic
on Mac) but Unix folks are SOL.

http://cvs-mirror.mozilla.org/webtools/lxr/ident?i=NET_AddExternalURLType

It's traditional (i.e. in libwww and lynx since '91 I think)
to allow folks to add their own URI schemes by
setting
	foo_proxy = http://www.w3.org/foo-proxy.cgi

(I personally want to add irc: and phone: to my desktop)
Comment 1 Gagan 1999-01-25 22:07:59 PST
Actually in the new world order, NET_MakeAbsoluteURL isn't called at all. Its
now handled by NS_MakeAbsoluteURL which will soon be changing to be protocol
specific. Hopefully that will make things easier for all. Thanks Dan for
pointing out the great links that will definitely help us test this!
Comment 2 Gagan 1999-01-25 22:30:59 PST
*** Bug 1640 has been marked as a duplicate of this bug. ***
Comment 3 Eli Goldberg 1999-01-29 14:12:59 PST
Raising to P1, as this is arguably a test blocker.

In particular, links can't be followed on a number of web sites.
Comment 4 Eli Goldberg 1999-01-29 14:13:59 PST
Raising to P1, as this is arguably a test blocker.

In particular, links can't be followed on a number of web sites.
Comment 5 leger 1999-02-03 08:04:59 PST
Setting all current Open Critical and Major to M3
Comment 6 Paul MacQuiddy 1999-02-22 18:07:59 PST
setting paulmac as QA contact for all gagan's bugs (sorry for the spam)
Comment 7 Suresh Duddi (gone) 1999-03-11 13:59:59 PST
N2 merge will fix it I trust. So are we going to fix this on the tip too. M3 or
not ?
Comment 8 Gagan 1999-03-11 14:23:59 PST
Fixed with N2.
Comment 9 glynn 1999-03-11 17:25:59 PST
removed myself from cc
Comment 10 Dan Connolly 1999-04-08 13:03:59 PDT
wtf? First I get "thanks for the detailed report and links
to test info" and then it's promoted to P1 major... I
was actually starting to hope that something might happen.

And now it's been put in the someday pile? I feel quite
disappointed and mislead.

Is there something I can do to help get this bug fixed?

I found the bug in the old code, but I was told that
was old code and it's obsolte. Would somebody show me
where the new code is so I can try to fix it?
Comment 11 Gagan 1999-04-08 13:16:59 PDT
Marking for M6. The new implementation I wrote works just fine. But it doesn't
go in until the new netlib does.
Comment 12 Gagan 1999-05-14 19:22:59 PDT
Per DP's suggestion marking these till M8. Though Necko lands with M7, we will
be able to verify it for M8.
Comment 13 James Everingham 1999-06-29 13:14:59 PDT
Moving to M9, Necko landing in M8
Comment 14 Gagan 1999-06-30 17:17:59 PDT
Pushed past necko landing...
Comment 15 leger 1999-07-20 12:16:59 PDT
Changing all Networking Library/Browser bugs to Networking-Core component for
Browser.

Occasionally, Bugzilla will burp and cause Verified bugs to reopen when I do
this in a bulk change.  If this happens, I will fix. ;-)
Comment 16 Gagan 1999-07-25 03:24:59 PDT
Please check with Necko. There is a test case for testing url parsing now in the
necko world. Its called urltest. And it also has an option to test making
absolute URL from relative ones. I know some of the cases are broken (;param
ones) and will fix it soon.
Comment 17 Paul MacQuiddy 1999-07-29 19:00:59 PDT
connolly, do you want to verify that this is fixed?
Comment 18 Paul MacQuiddy 1999-08-09 18:59:59 PDT
connolly, are you around? The new code is available if you would like to test it
out.
Comment 19 Dan Connolly 1999-08-12 01:08:59 PDT
I verified that URI parsing (e.g. irc://irc.w3.org/test)
works in
ftp://ftp.mozilla.org/pub/mozilla/nightly/latest/mozilla-win32.zip
of Wed Aug 11 13:58:00 1999
build ID 1998081108

I haven't tested the ability of users to add their own URI scheme handlers.


I wish the URI parsing interface were separate from the NS_OpenURL code,
but that's just style.
http://lxr.mozilla.org/seamonkey/source/network/public/nsIURL.h#35
Comment 20 Paul MacQuiddy 1999-08-12 10:37:59 PDT
thanks
Comment 21 leger 1999-12-13 16:39:59 PST
Bulk move of all Networking-Core (to be deleted component) bugs to new
Networking component.
Comment 22 J Luh 2001-02-07 08:20:19 PST
What ever became of the code to allow users to register URI schemes? This
functionality would probably make some people happy on bug 33282, bug 39714, and
bug 44317.
Comment 23 benc 2001-07-20 13:36:26 PDT
+makingtest
mailto and telnet are still misbehaving, I need to look at this more.

Note You need to log in before you can comment on or make changes to this bug.